/* --------------------------------------------------------
 Generated by Gunandi using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Gunandi (andri.gunandi1@gmail.com) 
 Date Created : 22/05/2019
 --------------------------------------------------------
*/
package com.portofolio.dao;

import  java.util.List;
import  java.util.Map;
import  org.springframework.cache.annotation.Cacheable;
import  org.springframework.data.domain.Page;
import  org.springframework.data.domain.Pageable;
import  org.springframework.data.jpa.repository.JpaRepository;
import  org.springframework.data.jpa.repository.Query;
import  org.springframework.data.repository.query.Param;
import  org.springframework.stereotype.Repository;

import com.portofolio.entity.MapModulAplikasiToObjekModul;
import com.portofolio.entity.ObjekModulAplikasi;
import com.portofolio.entity.vo.MapModulAplikasiToObjekModulId;


@Repository("mapModulAplikasiToObjekModulDao")
public interface MapModulAplikasiToObjekModulDao extends JpaRepository<MapModulAplikasiToObjekModul, MapModulAplikasiToObjekModulId> {


    @Query(QListAll)
    @Cacheable("MapModulAplikasiToObjekModulDaoFindAllList")
    Page<Map<String, Object>> findAllList(Pageable page);
    
    @Query(QListAll + " and model.objekModulAplikasi.namaObjekModulAplikasi like %:namaObjekModulAplikasi% ")
    @Cacheable("MapModulAplikasiToObjekModulDaoFindAllListPage")
    Page<Map<String, Object>> findAllList(@Param("namaObjekModulAplikasi") String namaObjekModulAplikasi, Pageable page);
    
    @Query(QListAll) 
     List<Map<String, Object>> findAllData();
    
    String QListAll ="select new map(model.id.kdVersion as kdVersion,model.id.kdObjekModulAplikasi as kdObjekModulAplikasi,model.id.kdModulAplikasi  as kdModulAplikasi"
+ ", objekModulAplikasi.kdObjekModulAplikasiHead as kdObjekModulAplikasiHead,objekModulAplikasi.id.kdObjekModulAplikasi as kdObjekModulAplikasi,modulAplikasi.namaModulAplikasi as namaModulAplikasi ,objekModulAplikasi.namaObjekModulAplikasi as namaObjekModulAplikasi"
+ ", model.noUrut as noUrut " 
+ ", model.statusEnabled as statusEnabled " 
+ ", model.noRec as noRec " 
+ ", model.version as version ,model.modulAplikasi as modulAplikasi,model.objekModulAplikasi as objekModulAplikasi )" 
+ " from MapModulAplikasiToObjekModul model left join model.id id left join model.modulAplikasi modulAplikasi left join model.objekModulAplikasi objekModulAplikasi where model.statusEnabled=true ";

    String QListAllV2 ="select new map(objekModulAplikasi.kdObjekModulAplikasiHead as kdObjekModulAplikasiHead,objekModulAplikasi.kdObjekModulAplikasi as kdObjekModulAplikasi,objekModulAplikasi.namaObjekModulAplikasi as namaObjekModulAplikasi ) "
    		+ " from ObjekModulAplikasi objekModulAplikasi   where   objekModulAplikasi.statusEnabled=true ";

    		    
    @Query("select model from MapModulAplikasiToObjekModul model left join model.id id left join model.modulAplikasi modulAplikasi left join model.objekModulAplikasi objekModulAplikasi where id.kdModulAplikasi=:kdModulAplikasi and id.kdVersion=:kdVersion  ")
	List<MapModulAplikasiToObjekModul> findOneBykode(@Param("kdModulAplikasi")String kdModulAplikasi, @Param("kdVersion")Integer kdVersion); 

    
    @Query(QListAll+" and id.kdModulAplikasi=:kdModulAplikasi and id.kdVersion=:kdVersion")
	List<Map<String,Object>> findOneBykodeMap(@Param("kdModulAplikasi")String kdModulAplikasi, @Param("kdVersion")Integer kdVersion); 

    
    @Query("select new map(model.kdObjekModulAplikasi as kdObjekModulAplikasi "
			+ ", model.namaObjekModulAplikasi as namaObjekModulAplikasi) "
			+ " from ObjekModulAplikasi model "
			+ " where model.namaObjekModulAplikasi like %:namaObj% ")
	List<Map<String, Object>> findAllListObj(@Param("namaObj") String namaObj);
    
    @Query(QListAllV2 +"and objekModulAplikasi.objekModulAplikasiHead is null")
	List<Map<String, Object>> findObjekModulAplikasiHeadIsNull();
    
    @Query(QListAllV2 +"and objekModulAplikasi.objekModulAplikasiHead is null  ")
   	List<Map<String, Object>> findObjekModulAplikasiHeadIsNullAndKdKelompokTransaksi();
       
    
    @Query(QListAllV2+" and objekModulAplikasi.kdObjekModulAplikasiHead=:kdObjekModulAplikasiHead ")
   	List<Map<String, Object>> findAllListByKdModulAplikasiAndKdVersionAndKdObjekModulAplikasiHead(@Param("kdObjekModulAplikasiHead") String kdObjekModulAplikasiHead);

    @Query("select new map(objekModulAplikasi.kdObjekModulAplikasiHead as kdObjekModulAplikasiHead,objekModulAplikasi.kdObjekModulAplikasi as kdObjekModulAplikasi,objekModulAplikasi.namaObjekModulAplikasi as namaObjekModulAplikasi,mapModulAplikasiToObjekModul.id.kdVersion as kdVersion,mapModulAplikasiToObjekModul.id.kdModulAplikasi as kdModulAplikasi ) "
    		+ " from MapModulAplikasiToObjekModul mapModulAplikasiToObjekModul left join mapModulAplikasiToObjekModul.objekModulAplikasi objekModulAplikasi where  mapModulAplikasiToObjekModul.statusEnabled=true and mapModulAplikasiToObjekModul.id.kdVersion=:kdVersion and mapModulAplikasiToObjekModul.id.kdModulAplikasi=:kodeModApp ")
	List<Map<String, Object>> findMapModulAplikasiToObjekModulByKdModulAplikasiAndKdVersion(@Param("kodeModApp")String kodeModApp,@Param("kdVersion") Integer kdVersion);

    
    
    String QSelectAll = "select model "
			+ " from ObjekModulAplikasi model "
			+ " left join model.mapObjekModulToKelompokUser mkUser "
			+ " left join model.mapModulAplikasiToObjekModul mmApp "
			+ " where mkUser.id.kdProfile = :kdProfile "
			+ " and mkUser.id.kdVersion = mmApp.id.kdVersion "
			+ " and mkUser.id.kdModulAplikasi = mmApp.id.kdModulAplikasi "
			+ " and mmApp.id.kdModulAplikasi = :kdModulAplikasi "
			+ " and mmApp.id.kdVersion = :kdVersion "
			+ " and mkUser.id.kdKelompokUser = :kdKelompokUser "
			+ " and mkUser.tampil = 1 "
			+ " and model.alamatURLFormObjek is not null "
			+ " and model.statusEnabled = true "
			+ " and mmApp.statusEnabled = true " 
			+ " and mkUser.statusEnabled = true";

	@Query(QSelectAll + " and model.kdObjekModulAplikasiHead = :kdObjekModulAplikasiHead ")
	List<ObjekModulAplikasi> findAllObjekModulAplikasiDaofindMenu(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdModulAplikasi") String kdModulAplikasi,
			@Param("kdVersion") Integer kdVersion, 
			@Param("kdKelompokUser") Integer kdKelompokUser,
			@Param("kdObjekModulAplikasiHead") String kdObjekModulAplikasiHead);
	
	@Query(QSelectAll + " and model.kdObjekModulAplikasiHead is null ")
	List<ObjekModulAplikasi> findAllObjekModulAplikasiDaofindMenu(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdModulAplikasi") String kdModulAplikasi,
			@Param("kdVersion") Integer kdVersion, 
			@Param("kdKelompokUser") Integer kdKelompokUser);
	
	
	String QSelectAllAdmin = "select model "
			+ " from ObjekModulAplikasi model "
			+ " left join model.mapModulAplikasiToObjekModul mmApp "
			+ " where mmApp.id.kdModulAplikasi = :kdModulAplikasi "
			+ " and mmApp.id.kdVersion = :kdVersion "
			+ " and model.alamatURLFormObjek is not null "
			+ " and model.statusEnabled = true "
			+ " and mmApp.statusEnabled = true " ;

	@Query(QSelectAllAdmin + " and model.kdObjekModulAplikasiHead = :kdObjekModulAplikasiHead ")
	List<ObjekModulAplikasi> findAllObjekModulAplikasiDaofindMenuAdmin(
			@Param("kdVersion") Integer kdVersion, 
			@Param("kdModulAplikasi") String kdModulAplikasi,
			@Param("kdObjekModulAplikasiHead") String kdObjekModulAplikasiHead);
	
	@Query(QSelectAllAdmin + " and model.kdObjekModulAplikasiHead is null ")
	List<ObjekModulAplikasi> findAllObjekModulAplikasiDaofindMenuAdmin(
			@Param("kdVersion") Integer kdVersion, 
			@Param("kdModulAplikasi") String kdModulAplikasi);

}
